#!/usr/bin/sudo /bin/bash
#exit 0
. /home/ROULETTE/common.config #here is configuration of ROULETTE and FC5 locations

#preverimo ali je prikljucen monitor, ce ni, ustvarimo desktop na virtual head, da lahko dela anydesk
xrandr --query |grep -v disconnected|grep connected >> /dev/null
IS_HEADLESS=$?
if [ $IS_HEADLESS -ne 0 ]; then
	xrandr -d :0 --output VIRTUAL1 --primary --auto
#	xrandr -d :0 --output VIRTUAL2 --primary --auto
	xrandr --newmode "1600x900_60.00" 118.25 1600 1696 1856 2112 900 903 908 934 -hsync +vsync
	xrandr --addmode VIRTUAL1 "1600x900_60.00"
#	xrandr --addmode VIRTUAL2 "1600x900_60.00"
fi 

#functions
RunTWAfterInternetOK()
{
        #start teamviewer
        PING_RES=1
        while [ 0 -ne $PING_RES ]; do
                echo "Waiting for internet connection..."
                ping -c 1 www.google.com
                PING_RES=$?
                sleep 2
        done



        echo "Please wait...starting AnyDesktop"
	nohup $ROULETTE/restartAnydesk.sh &
return 0
}

TestInternetAndShowConfigIfNot()
{
	#nekateri sistemi rabijo dodatni ip naslov, prikazemo konfiguracijo uporabniku, da izbere karto
	ping -c 1 -t 5  10.5.10.254
	if [ "0" != $? ]; then
        	echo "Warning"
	        echo "Warning: NOT A VALID IP ADDRESS CONFIGURED. PLEASE MAKE SURE AT LEAST ONE ADAPTER HAS IP 10.5.10.254"
        	echo "Warning"
	        notify-send "Please select a network card for system.     It will be assigned IP=10.5.10.254"
        	sudo -u user sudo gedit /etc/network/interfaces
	        service networking restart
#        	sudo -u user sudo gedit /etc/netplan/01-netcfg.yaml
#		sudo neplan apply
  
	      	ping -c 1 -t 5  10.5.10.254
	        if [ "0" != $? ]; then 
		        notify-send "Network settings error!!!! Please restart.."
        	        return 1
	        fi
	fi;
return 0
}

if [ -d /rofs/etc ]; then
   echo "Running from live CD, must install before running roulette."
   echo "Starting installer"
   echo
   notify-send "Starting installer"

   sudo ubiquity &
   RunTWAfterInternetOK
   exit 0
fi

echo "This system is installed to HD"

ps -A|grep roulettemaster 2>/dev/null 1>/dev/null; [ 0 -eq $? ] && { 
  echo "$PRODUCT_NAME is already running..attaching to window..."
  lxterminal --command="screen -d -RR" --title="RouletteMaster console" --geometry=170x70 &
  exit 0
}


if [ ! -f $FIRSTBOOTFILE ]; then
  #TUKAJ DODAJ AKCIJE OB PRVEM ZAGONU PO INSTALACIJI

  echo "Patching installation for $PRODUCT_NAME"
  notify-send "Patching installation for $PRODUCT_NAME. Will restart when done...."

  $ROULETTE/OneAmazingScript.sh $ROULETTE/initial_config/etc/network/interfaces $ROULETTE/initial_config/etc/default/isc-dhcp-server $ROULETTE/initial_config/etc/ufw/before.rules
  /bin/cp -R $ROULETTE/initial_config/* /
  service networking restart

  #izkjlucimno update notifier
  gsettings set com.ubuntu.update-notifier no-show-notifications true
  sudo -u user dconf write "/org/compiz/profiles/unity/plugins/unityshell/launcher-hide-mode" 1

  #ob prvem zagonu po instalaciji moramo ponovno izracunati kjluce za sshd
  dpkg-reconfigure openssh-server
  update-grub

  TestInternetAndShowConfigIfNot

  #wine-u nastavimo memorysize - potrebno za GameART igre
  winetricks videomemorysize=1024

  if [ -f "$ROULETTE/postinstaller.sh" ]; then
    lxterminal --command="$ROULETTE/postinstaller.sh" --title="$PRODUCT_NAME postinstaller" --geometry=170x70 &
    wait $!
  fi

  echo "select * from set_param('ROULETTE', 'INIT.SH', 'PRODUCT_NAME', '','', 11, 0, '$PRODUCT_NAME')" |$ROULETTE/sqlexec.sh

  echo "roulettefirstboot has already been run" > $FIRSTBOOTFILE
  echo "delete this file to run it again." >> $FIRSTBOOTFILE
sleep 1
init 6 #moramo narediti restart, sedaj ko smo vse namestili..., se dogaja, da se network ne postavi pravilno dokler 1x ne restartamo!
fi;

#preverimo internet
#ce ne interneta se ne bo zagnala!!
#TestInternetAndShowConfigIfNot
echo "Starting $PRODUCT_NAME"
notify-send "Starting $PRODUCT_NAME"


# service network-manager stop

#nalozimo module tun - za OpenVPN v FC5
modprobe tun
echo $FC5


#obsolete cat $FC5/etc/resolv.conf > /etc/resolv.conf
#ln -f $FC5/etc/resolv.conf /etc/resolv.conf
cp -f $FC5/etc/resolv.conf /etc/resolv.conf

aumix -v100 -w100 -W100 -i100 -l100
sleep 1

$ROULETTE/vnc-server-keepalive.sh & #startamo vnc server v ozadje na port-u 5900

#pripravimo directory-je za serivse iz ubuntu
#mkdir -p /tftpboot
#mkdir -p /ClientRoot
#mkdir -p /data
#mount --bind $FC5/tftpboot /tftpboot
#mount --bind $FC5/ClientRoot /ClientRoot
#mount --bind $FC5/data /data
#ln -snf /data/ClientHome /ClientHome
mount --bind /home/ROULETTE $FC5/home/ROULETTE
mount --bind /home/ROULETTE/terminal_home $FC5/ClientHome

#service dhcp3-server stop #prej je to bilo v FC5, zdaj je LTSP
#service tftpd-hpa stop #prej je to bilo v FC5, zdaj je LTSP
service isc-dhcp-server restart
service tftpd-hpa restart

#ubuntu nfs service, ker so bile tezave z nfs iz fedore
service portmap start
sleep 1
exportfs -a
exportfs
#service nfs-common start
service nfs-kernel-server start

#da lahko user dostpoa iz pope do serijskih portov
chmod 777 /dev/ttyS0
chmod 777 /dev/ttyS1
chmod 777 /dev/ttyS2
chmod 777 /dev/ttyS3
chmod 777 /dev/ttyUSB0
chmod 777 /dev/ttyUSB1
chmod 777 /dev/ttyUSB2
chmod 777 /dev/ttyUSB3

#this may be useful when working from FC5 shell
mount --bind / /$FC5/mnt/host_system
mount --bind /proc $FC5/proc
mount --bind /dev $FC5/dev
mount --bind /sys $FC5/sys
mkdir -p $FC5/lib/modules/`uname -r`
mount --bind /lib/modules/`uname -r` $FC5/lib/modules/`uname -r`

#mount ramdisks for VER folders 
if [[ $PRODUCT_NAME == *"SinglePlayer"* ]]; then
	$ROULETTE/mount_VER_ramdisks.sh
#todo, za multiplayer, je potrebno mountati vsak NFS share na svoj ramdisk
fi

#zazenemo ruleto v $FC5
#lxterminal --command="screen chroot $FC5 /init_fc5.sh" --title="$PRODUCT_NAME console" --geometry=170x70 &
sleep 1 #to sem dodal, ker se kaksenkrat ni zagnala FC5, mislim da je zdaj ok.
screen -dmS FedoraCore5
screen -S FedoraCore5 -X stuff ' chroot '$FC5' /init_fc5.sh\n'

#ni vec potrebno, uporabljamo screen#sleep 2
##ce nismo bili uspesni z zagonom terminala, potem zazenemo samo da tece
##ps -A|grep lxterminal 2>/dev/null 1>/dev/null; [ 0 -eq $? ] || nohup chroot $FC5 /init_fc5.sh
ps -A|grep -v gnome-screen|grep screen 2>/dev/null 1>/dev/null; [ 0 -eq $? ] || nohup chroot $FC5 /init_fc5.sh

echo "$PRODUCT_NAME chroot environment was started and running..."
echo `date`": System POWER ON">>$FC5/boot.log
sleep 3 #da uspe init_FC5.sh izbrisati fc5initcomplete.status datoteko
while ! [ -f $FC5/fc5initcomplete.status ];
do 
        sleep 1
        echo "Waiting for init_fc5.sh to complete"
done



#$ROULETTE/installer_web.sh 7 #run game container
#$ROULETTE/installer_web.sh 9 #run video relay container
#sleep 5
#$ROULETTE/installer_web.sh 33 #start FFmpeg audio/video


#ni vec potrebno, uporabljamo screen#skrijemo okno
#wmctrl -r "$PRODUCT_NAME console" -b toggle,shaded

#zazenemo symmetricds
#$ROULETTE/symmetricDS/bin/RUN_SYM.sh #ga zazene ze systemd
#zazenemo keepalive za symmetricDS
echo Starting symmetricDS KeepAlive
nohup /home/ROULETTE/symmetricds-keepalive.sh 2>/dev/null 1>/dev/null & 
echo OK.

#before starting program, we check if a _update file is pending as program update - usefull to update at next reboot
binaries_to_update="$ROULETTE/terminal/roulettebillboard $ROULETTE/terminal/rouletteterminal_generic $ROULETTE/terminal/ladyroulette $ROULETTE/terminal/igplatform $ROULETTE/terminal/gamearttopscreen"
for BIN_FILENAME in $binaries_to_update
do
   if [ -e $BIN_FILENAME"_update" ]; then
      echo
      echo "    "Updating $BIN_FILENAME with file $BIN_FILENAME"_update"
      echo "    "Old version will be renamed to $BIN_FILENAME"_old"
      echo

      mv -f $BIN_FILENAME $BIN_FILENAME"_old" > /dev/null
      mv -f $BIN_FILENAME"_update" $BIN_FILENAME > /dev/null
      chmod ugo+x $BIN_FILENAME
   fi;
done


#
#ali je masina aktivirana, ce ni, moramo najprej zagnati POPE Activation
#
echo "select RES_NUM_VALUE,RES_STR_VALUE from GET_PARAM('ROULETTE', 'LICENSED_TO', 11)" | $ROULETTE/sqlexec.sh | grep "UNREGISTRED\|<null> <null>"  2>&1 1>/dev/null
if [ $? -ne 0 ]; then
#        echo Activated, hiding unity plugin
	echo "Product $PRODUCT_NAME is activated and licensed to "`cat $FC5/RouletteMaster/licensed.to`;
else
        echo "Product is not Activated, running Pope with activation...";
	#moramo ugasniti roulettemaster, ker nam lahko ugasa masino, ce ni sniffer-ja
	chroot $FC5 service crond stop
	chroot $FC5 service roulette kill
        nohup $ROULETTE/popeinit.sh -activate -fullscreen &
	wait $!
	exit
fi


#
# ZAGON PRODUKTA
#
#screen -S wssh -dm bash -c "cd /home/ROULETTE/terminal; ./RUN_WSSH.sh; exit"  
#screen -S imaxanode -dm bash -c "sleep 3; cd /home/ROULETTE/terminal; ./RUN_NODE.sh; exit"  


KERNEL_VERSION=`uname -r`
echo "select * from set_param('ROULETTE', 'INIT.SH', 'SYS_KERNEL_VERSION', '','', 11, 0, '$KERNEL_VERSION')" |$ROULETTE/sqlexec.sh
FREE_SPACE=`df -h|grep /dev/sda`
echo "select * from set_param('ROULETTE', 'NOCHANGELOG', 'SYS_FREE_SPACE', '','', 11, 0, '$FREE_SPACE')" |$ROULETTE/sqlexec.sh
#$ROULETTE/roulettesnd.sh start
cd $ROULETTE/terminal
./RUN_APP.sh
if [[ $PRODUCT_NAME != *"SinglePlayer"* && $PRODUCT_NAME != *"LadyRoulette"* ]]; then
	#prikazemo screen rulete
	/usr/bin/lxterminal --command="sudo screen -r FedoraCore5" --title="RouletteMaster console" --geometry=110x45 &
	#sicer zazenemo roulette daemon-a, in nadaljujemo, sleep 120 mora biti, da master na zacetku preveri ali so se postaje povezale in jih v nasprotnem primeru restart-a
	#export WINEPREFIX="/home/user/.wine";
	su user -c "sleep 160; nohup wine \"C:\\Program Files\\Pope\\RouletteDeamon.exe\" 2>/dev/null 1>/dev/null" &
	#mora biti sleep 160, ker sicer ne dela no_reset_min_connections v master-ju

fi



#ce je SinglePlayer ugasnemo boot from lan serise
if [[ $PRODUCT_NAME == *"SinglePlayer"* ]]; then
    #ugasnemo isc-dhcpd in tftpd iz ltsp
    service isc-dhcp-server stop
    service tftpd-hpa stop
else
    #zazenemo isc-dhcpd in tftpd iz ltsp
    service isc-dhcp-server restart
    service tftpd-hpa restart
fi

RunTWAfterInternetOK
sleep 5 #pocakamo zagon anydesk-a
#TODO ANYDESK ID!!!
#if [ -f $ROULETTE/teamviewer6/profile/system.reg ]; then
#echo $((0x`cat $ROULETTE/teamviewer6/profile/system.reg |grep ClientID|cut -c 18-`)) > $FC5/RouletteMaster/TEAMVIEWER_ID
#fi

#if [ -f $ROULETTE/teamviewer7/profile/system.reg ]; then
#echo $((0x`cat $ROULETTE/teamviewer7/profile/system.reg |grep ClientID|cut -c 1
#8-`)) > $FC5/RouletteMaster/TEAMVIEWER_ID
#fi

#
# TO MISLIM DA JE UNREACHABLE CODE
#

#moramo resetirati firewall, ko sta se kartici aktivirali sicer nagaja
#firewall stop
#sleep 1
#firewall start


exit 0
