#!/bin/bash

. ./terminal.config

#binary name, ki ga bomo zagnali
export BIN_FILENAME=/$HOME_DIR/imaxanode
#killall service name
killall -s9 imaxanode

#mehanizem za rotiranje log-file-ov
TERMINAL_NUMBER=$1
if [ -z "$TERMINAL_NUMBER" ];then
        TERMINAL_NUMBER=1
fi
OLD_GAMES_DIR=$OLD_GAMES_DIR"/10.5.10."$TERMINAL_NUMBER
mkdir -p $OLD_GAMES_DIR

declare -x LOG_FILENAME=$OLD_GAMES_DIR"/imaxanode.log"
export 1>/dev/null 2>/dev/null

#zazenemo binary
echo "RUN_NODE.SH: Loading libraries from $LIBS_PATH"

#before starting program, we check if a _update file is pending as program update - usefull to update at next reboot
if [ -e $BIN_FILENAME"_update" ]; then
   echo
   echo "    "Updating $BIN_FILENAME with file $BIN_FILENAME"_update"
   echo "    "Old version will be renamed to $BIN_FILENAME"_old"
   echo

   mv -f $BIN_FILENAME $BIN_FILENAME"_old" > /dev/null
   mv -f $BIN_FILENAME"_update" $BIN_FILENAME > /dev/null
   chmod ugo+x $BIN_FILENAME
fi;


export DISABLE_REBOOT_ON_EXIT=1
export CONFIGURATION=services_conf/node.conf
export CONFIGURATION_USER=/var/IGP/node_override.conf

LD_LIBRARY_PATH=$LIBSV7_PATH $BIN_FILENAME

exit 0;

